'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class;

var _playerObject = require('./decorators/playerObject');

var _playerObject2 = _interopRequireDefault(_playerObject);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var propertyBlacklist = ['_floor', '_x', '_y', 'constructor', 'location', 'unit', 'toString'];

var Space = (_dec = (0, _playerObject2.default)(propertyBlacklist), _dec(_class = function () {
  function Space(floor, x, y) {
    _classCallCheck(this, Space);

    this._floor = floor;
    this._x = x;
    this._y = y;
  }

  _createClass(Space, [{
    key: 'isWall',
    value: function isWall() {
      var _floor;

      return (_floor = this._floor).isOutOfBounds.apply(_floor, _toConsumableArray(this.location));
    }
  }, {
    key: 'isWarrior',
    value: function isWarrior() {
      return !!this.unit && this.unit.type === 'warrior';
    }
  }, {
    key: 'isPlayer',
    value: function isPlayer() {
      return this.isWarrior();
    }
  }, {
    key: 'isEnemy',
    value: function isEnemy() {
      return !!this.unit && !this.isPlayer() && !this.isCaptive();
    }
  }, {
    key: 'isCaptive',
    value: function isCaptive() {
      return !!this.unit && this.unit.isBound();
    }
  }, {
    key: 'isTicking',
    value: function isTicking() {
      return !!this.unit && 'explode' in this.unit.abilities;
    }
  }, {
    key: 'isEmpty',
    value: function isEmpty() {
      return !this.unit && !this.isWall();
    }
  }, {
    key: 'isStairs',
    value: function isStairs() {
      var _floor$stairsLocation = _slicedToArray(this._floor.stairsLocation, 2);

      var stairsX = _floor$stairsLocation[0];
      var stairsY = _floor$stairsLocation[1];

      var _location = _slicedToArray(this.location, 2);

      var x = _location[0];
      var y = _location[1];

      return stairsX === x && stairsY === y;
    }
  }, {
    key: 'toString',
    value: function toString() {
      if (this.unit) {
        return this.unit.toString();
      }

      if (this.isWall()) {
        return 'wall';
      }

      return 'nothing';
    }
  }, {
    key: 'location',
    get: function get() {
      return [this._x, this._y];
    }
  }, {
    key: 'unit',
    get: function get() {
      var _floor2;

      return (_floor2 = this._floor).getUnitAt.apply(_floor2, _toConsumableArray(this.location));
    }
  }]);

  return Space;
}()) || _class);
exports.default = Space;