'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class;

var _Sense = require('./abilities/senses/Sense');

var _Sense2 = _interopRequireDefault(_Sense);

var _playerObject = require('./decorators/playerObject');

var _playerObject2 = _interopRequireDefault(_playerObject);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var propertyBlacklist = ['_action', '_senses', 'constructor', '_addAction', '_addSense', 'action'];

var Turn = (_dec = (0, _playerObject2.default)(propertyBlacklist), _dec(_class = function () {
  function Turn(abilities) {
    var _this = this;

    _classCallCheck(this, Turn);

    this._action = null;
    this._senses = {};

    Object.entries(abilities).forEach(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2);

      var name = _ref2[0];
      var ability = _ref2[1];

      if (ability instanceof _Sense2.default) {
        _this._addSense(name, ability);
      } else {
        _this._addAction(name);
      }
    });
  }

  _createClass(Turn, [{
    key: '_addAction',
    value: function _addAction(name) {
      var _this2 = this;

      Object.defineProperty(this, name, {
        value: function value() {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          if (_this2.action) {
            throw new Error('Only one action can be performed per turn.');
          }

          _this2._action = [name, args];
        }
      });
    }
  }, {
    key: '_addSense',
    value: function _addSense(name, sense) {
      var _this3 = this;

      this._senses[name] = sense;
      Object.defineProperty(this, name, {
        value: function value() {
          var _senses$name;

          return (_senses$name = _this3._senses[name]).perform.apply(_senses$name, arguments);
        }
      });
    }
  }, {
    key: 'action',
    get: function get() {
      return this._action;
    }
  }]);

  return Turn;
}()) || _class);
exports.default = Turn;