'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _directions = require('../../constants/directions');

var _Action2 = require('./Action');

var _Action3 = _interopRequireDefault(_Action2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_DIRECTION = _directions.FORWARD;
var TARGET_DAMAGE_AMOUNT = 8;
var COLATERAL_DAMAGE_AMOUNT = 4;
var SURROUNDINGS = [[1, 1], [1, -1], [2, 0], [0, 0]];

var Detonate = function (_Action) {
  _inherits(Detonate, _Action);

  function Detonate() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    _classCallCheck(this, Detonate);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(Detonate)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this._description = 'Detonate a bomb in a given direction (' + DEFAULT_DIRECTION + ' by default) which ' + 'damages that space and surrounding 4 spaces (including yourself).', _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Detonate, [{
    key: 'perform',
    value: function perform() {
      var _this2 = this;

      var direction = arguments.length <= 0 || arguments[0] === undefined ? DEFAULT_DIRECTION : arguments[0];

      this._verifyDirection(direction);

      if (this._unit.isAlive()) {
        this._unit.say('detonates a bomb ' + direction + ' launching a deadly explosion');

        var targetSpace = this._getSpace(direction, 1, 0);
        this._bomb(targetSpace, TARGET_DAMAGE_AMOUNT);

        SURROUNDINGS.map(function (_ref) {
          var _ref2 = _slicedToArray(_ref, 2);

          var x = _ref2[0];
          var y = _ref2[1];
          return _this2._getSpace(direction, x, y);
        }).forEach(function (surroundingSpace) {
          return _this2._bomb(surroundingSpace, COLATERAL_DAMAGE_AMOUNT);
        });
      }
    }
  }, {
    key: '_bomb',
    value: function _bomb(space, damageAmount) {
      var receiver = space.unit;
      if (receiver) {
        if ('explode' in receiver.abilities) {
          receiver.say('caught in bomb\'s flames which detonates ticking explosive');

          receiver.abilities.explode.perform();
        } else {
          this._damage(receiver, damageAmount);
        }
      }
    }
  }]);

  return Detonate;
}(_Action3.default);

exports.default = Detonate;