'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _directions = require('../../constants/directions');

var _Action2 = require('./Action');

var _Action3 = _interopRequireDefault(_Action2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_DIRECTION = _directions.FORWARD;
var RESCUING_BONUS = 20;

var Rescue = function (_Action) {
  _inherits(Rescue, _Action);

  function Rescue() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    _classCallCheck(this, Rescue);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(Rescue)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this._description = 'Rescue a captive from his chains (earning ' + RESCUING_BONUS + ' points) in the' + ('given direction (' + DEFAULT_DIRECTION + ' by default).'), _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Rescue, [{
    key: 'perform',
    value: function perform() {
      var direction = arguments.length <= 0 || arguments[0] === undefined ? DEFAULT_DIRECTION : arguments[0];

      this._verifyDirection(direction);

      if (this._getSpace(direction).isCaptive()) {
        var recipient = this._getUnit(direction);

        this._unit.say('unbinds ' + direction + ' and rescues ' + recipient);

        recipient.unbind();
        if (recipient.type === 'captive') {
          recipient.position = null;

          this._unit.earnPoints(RESCUING_BONUS);
        }
      } else {
        this._unit.say('unbinds ' + direction + ' and rescues nothing');
      }
    }
  }]);

  return Rescue;
}(_Action3.default);

exports.default = Rescue;