'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash.range');

var _lodash2 = _interopRequireDefault(_lodash);

var _directions = require('../../constants/directions');

var _Action2 = require('./Action');

var _Action3 = _interopRequireDefault(_Action2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_DIRECTION = _directions.FORWARD;
var ATTACK_RANGE = 3;

var Shoot = function (_Action) {
  _inherits(Shoot, _Action);

  function Shoot() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    _classCallCheck(this, Shoot);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(Shoot)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this._description = 'Shoot your bow & arrow in given direction (' + DEFAULT_DIRECTION + ' by default).', _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Shoot, [{
    key: 'perform',
    value: function perform() {
      var direction = arguments.length <= 0 || arguments[0] === undefined ? DEFAULT_DIRECTION : arguments[0];

      this._verifyDirection(direction);

      var receiver = this._getUnits(direction, (0, _lodash2.default)(1, ATTACK_RANGE + 1))[0];
      if (receiver) {
        this._unit.say('shoots ' + direction + ' and hits ' + receiver);

        this._damage(receiver, this._unit.shootPower);
      } else {
        this._unit.say('shoots ' + direction + ' and hits nothing');
      }
    }
  }, {
    key: '_getUnits',
    value: function _getUnits(direction, offsets) {
      var _this2 = this;

      return offsets.map(function (offset) {
        return _this2._getUnit(direction, offset);
      }).filter(function (unit) {
        return unit;
      });
    }
  }]);

  return Shoot;
}(_Action3.default);

exports.default = Shoot;